image: docker:stable
services:
  - docker:18-dind
variables:
  DOCKER_HOST: tcp://docker:2375
  IMAGE_LATEST: $REGISTRY_USER/$IMAGE_NAME:latest

stages:
  - build
  - npm
  - test
  - deploy

build:
  stage: build
  script:
    - docker build --cache-from $IMAGE_LATEST -t $IMAGE_LATEST .

npm:
  stage: npm
  image: node:latest
  script:
    - npm config set registry ${CI_NPM_REGISTRY}
    - npm install
  cache:
    paths:
      - node_modules/
  artifacts:
    expire_in: 1 days
    when: on_success
    paths:
      - node_modules/

test:
  stage: test
  image: node:latest
  dependencies:
    - npm
  script:
    - npm test
    - echo "running scripts in the test job"

deploy:
  stage: deploy
  before_script:
    - echo "$REGISTRY_PASSWORD" | docker login -u "$REGISTRY_USER" "$CI_REGISTRY" --password-stdin
  image: docker:stable
  script:
    - docker build --cache-from $IMAGE_LATEST -t $IMAGE_LATEST .
    - docker push $IMAGE_LATEST
    - echo "running scripts in the deploy job"

